package edu.laura.temaValaszt.choose;

import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;

import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.Preparable;

import edu.laura.temaValaszt.beans.ProjectBean;
import edu.laura.temaValaszt.beans.StudentBean;
import edu.laura.temaValaszt.login.LoginAction;

public class ChooseAction extends ActionSupport implements SessionAware, Preparable{

	private static final long serialVersionUID = 1L;

	//a temak listaja
	private List<ProjectBean> list;
	
	//a bejelentkezett diak adatai
	private StudentBean personBean;

	//a bejelentjkezett diak altal kivalasztott tema
	private Integer selectedProject;
	
	//szabad temak listaja:
	private List<ProjectBean> unassignedProjects;
	
	//tema-diak hozzarendeles (tema ID -> StudentBean)
	private Map<Integer, StudentBean> studentsForProjectMap;
	
	//a bejelentkezett diak altal javasolt (es valasztott) uj tema
	private String newProject;
	

	//	a bejelentkezett diak altal javasolt (es valasztott) uj tema leirasa
	private String newProjectDescription;

	
	private Map<String, Object> session;
	
	boolean chosen = false;
	
	//a prepare interceptorral mukodik kozre, beallitja a personBean-t a bejelentkezett felhasznalo
	//adataival, amit a szessziobol vesz.
	public void prepare() throws Exception {
		personBean=(StudentBean) session.get(LoginAction.LOGGEDSTUD);
	}

	public void setSession(Map session) {
		this.session = session;
	}

	//feltolti a list listat az adatbazisbol
	//+elobb ellenorzi, hogy be vagyunk-e jelentkezve
	//(a personBean-t beallitotta a prepare() )
	public String execute(){
		if(personBean==null){
		  return ERROR;
		}
		list=ChooseBL.getProjectList(personBean.getObjectID());
		unassignedProjects=ChooseBL.getUnassignedThemes();
		studentsForProjectMap = ChooseBL.getStudentsForProjectMap();
		chosen = ChooseBL.hasProject(studentsForProjectMap, personBean.getObjectID());
		return INPUT;
	}
	
	
	//a bejelentkezett diak visszavonja a valasztasat
	public String remove(){
		if(personBean==null){
			  return ERROR;
		}
		
		ChooseBL.remove(personBean.getObjectID());
		return execute();
	}
	
	//a bejelentkezett diak kivalaszt egy megadott temat
	public String assign(){
		if(personBean==null){
			  return ERROR;
		}
		
		ChooseBL.assign(personBean.getObjectID(),selectedProject);
		return execute();
	}
	
	//a bejelentkezett diak uj temat javasol, azt egyben ki is valasztja maganak
	public String newTheme(){
		if(personBean==null){
			  return ERROR;
		}
		
		if("".equals(newProject)|| (newProject==null)){
			addFieldError("newProject", "A cím megadása kötelező!");
		}
		else{
			ChooseBL.newTheme(newProject,newProjectDescription,personBean.getObjectID()); 
		}
		return execute();
	}
	
	public List<ProjectBean> getList() {
		return list;
	}

	public List<ProjectBean> getUnassignedProjects() {
		return unassignedProjects;
	}

	public Integer getSelectedProject() {
		return selectedProject;
	}

	public void setSelectedProject(Integer selectedProject) {
		this.selectedProject = selectedProject;
	}

	public String getNewProject() {
		return newProject;
	}

	public void setNewProject(String newProject) {
		this.newProject = newProject;
	}

	public String getNewProjectDescription() {
		return newProjectDescription;
	}

	public void setNewProjectDescription(String newProjectDescription) {
		this.newProjectDescription = newProjectDescription;
	}

	public Map<Integer, StudentBean> getStudentsForProjectMap() {
		return studentsForProjectMap;
	}

	public boolean isChosen() {
		return chosen;
	}
	
}
