package edu.laura.temaValaszt.dao;

import edu.laura.temaValaszt.jdbc.JDBCDAOFactory;

public abstract class DAOFactory {
	
	public static DAOFactory instance;
	
	public static DAOFactory getFactory() {
		if (instance==null) {
			instance = new JDBCDAOFactory();
		}
		return instance;
	}
 	
	
	public abstract ProjectDAO getProjectDAO();
	public abstract StudentDAO getStudentDAO();
	public abstract StudentToProjectDAO getStudentToProjectDAO();
}
