package edu.laura.temaValaszt.jdbc;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.LinkedList;
import java.util.List;

import edu.laura.temaValaszt.beans.ProjectBean;
import edu.laura.temaValaszt.dao.ProjectDAO;

public class ProjectDAOJDBC implements ProjectDAO {
	
	public List<ProjectBean> getAllProjects() {
		try {
			return getProjectBeansFromSelect(
					"SELECT * FROM project;");
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}	
	}
	
	public ProjectBean loadByProjectID(Integer objectID) {
		return getProjectBeanFromSelect(
				"SELECT * FROM project p WHERE p.ObjectID="+objectID);
	}
	
	public Integer saveProject(ProjectBean projectBean) {
		return JDBCUtil.returnKeyInsert("INSERT INTO project (Title, Description, ProposedBy, State) " +
	     		"VALUES ('"+projectBean.getTitle()+"', '"+
	     		projectBean.getDescription()+"',"+projectBean.getProposedBy()+
	     		","+projectBean.getStatus()+")");
	}
	
	public void removeByProjectID(Integer projectID) {
		JDBCUtil.executeUpdate("DELETE FROM project WHERE ObjectID="+projectID+";");
	}
	
	public List<ProjectBean> getUnassignedProjects() {
		try {
			return getProjectBeansFromSelect("SELECT p.* " +
					"FROM project p left outer join studenttoproject sp on p.ObjectID=sp.ProjectID " +
					"WHERE sp.ObjectID IS NULL;");
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	private static ProjectBean getProjectBeanFromSelect(String selectStatement) {
		Connection connection = JDBCDataSource.getConnection();
		Statement statement;
		ProjectBean projectBean=null;
		try {
			statement = connection.createStatement();
			ResultSet resultSet = statement.executeQuery(selectStatement);
			while (resultSet.next()) {
				projectBean = getProjectBeanFromResultSetRecord(resultSet);
			}
			resultSet.close();
			statement.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		finally {
			try {
				connection.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return projectBean;
	}
	
	private static List<ProjectBean> getProjectBeansFromSelect(String selectStatement) throws SQLException {
		Connection connection = JDBCDataSource.getConnection();
		Statement statement;
		List<ProjectBean> list=new LinkedList<ProjectBean>();
		try {
			statement = connection.createStatement();
			ResultSet resultSet = statement.executeQuery(selectStatement);
			while (resultSet.next()) {
				list.add(getProjectBeanFromResultSetRecord(resultSet));
			}
			resultSet.close();
			statement.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		finally {
			try {
				connection.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return list;
	}
	
	private static ProjectBean getProjectBeanFromResultSetRecord(ResultSet resultSet) throws SQLException {
		ProjectBean projectBean = new ProjectBean() ;
		projectBean.setObjectID(Integer.valueOf(resultSet.getInt("ObjectID")));
		projectBean.setTitle(resultSet.getString("Title"));
		projectBean.setProposedBy(Integer.valueOf(resultSet.getInt("ProposedBy")));
		projectBean.setStatus(Integer.valueOf(resultSet.getInt("State")));
		return projectBean;
	}
}
