package edu.laura.temaValaszt.jdbc;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.LinkedList;
import java.util.List;

import edu.laura.temaValaszt.beans.StudentToProjectBean;
import edu.laura.temaValaszt.dao.StudentToProjectDAO;

public class StudentToProjectDAOJDBC implements StudentToProjectDAO {
	
	public List<StudentToProjectBean> getAllAssignments() {
		try {
			return getStudentToProjectBeansFromSelect(
					"SELECT * FROM studenttoproject;");
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}	
		
	}
	
	// a studenttoproject tablaba beir egy uj bejegyzest
	//a StudentID azonositoju diak kivalasztotta a ProjectID azonositoju temat
	public Integer assign(Integer studentID, Integer projectID){
		return JDBCUtil.returnKeyInsert("INSERT INTO studenttoproject (ProjectID, StudentID) " +
		     		"VALUES ("+projectID+", "+studentID+");");
	}
	
	public void deleteByStudentID(Integer studentID){
		JDBCUtil.executeUpdate("DELETE FROM studenttoproject WHERE StudentID="+studentID+";");
	}
	
	public StudentToProjectBean loadByStudentID(Integer studentID) {
		return getStudentToProjecBean("SELECT * " +
	  	 		"FROM studenttoproject sp " +
	     		"WHERE sp.StudentID="+studentID);
	}
	
	private static List<StudentToProjectBean> getStudentToProjectBeansFromSelect(String selectStatement) throws SQLException {
		Connection connection = JDBCDataSource.getConnection();
		//SQL parancs:
		Statement statement;
		List<StudentToProjectBean> list=new LinkedList<StudentToProjectBean>();
		try {
			statement = connection.createStatement();
			ResultSet resultSet = statement.executeQuery(selectStatement);
			while (resultSet.next()) {
				list.add(getStudentToProjecBeanFromResultSetRecord(resultSet));
			}
			resultSet.close();
			statement.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		finally {
			try {
				connection.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return list;
	}
	
	private static StudentToProjectBean getStudentToProjecBean(String selectStatement) {
		Connection connection = JDBCDataSource.getConnection();
		Statement statement=null;
		StudentToProjectBean studentToProjectBean=null;
		ResultSet resultSet=null;
		try {
			statement = connection.createStatement();
			resultSet = statement.executeQuery(selectStatement);
		    if(resultSet.next()){
		    	studentToProjectBean = getStudentToProjecBeanFromResultSetRecord(resultSet);
		    }
		} catch (SQLException e) {
			e.printStackTrace();
		}
		finally {
			try {
				resultSet.close();
			} catch (Exception e) {
				// TODO: handle exception
				// pl. lehet log-ot irni...
			}
			try {
				statement.close();
			} catch (Exception e) {
			}
			try {
			    connection.close();
			} catch (Exception e) {
			}
		}
	    return studentToProjectBean;
	}
	
	private static StudentToProjectBean getStudentToProjecBeanFromResultSetRecord(ResultSet resultSet) throws SQLException {
		StudentToProjectBean studentToProjectBean = new StudentToProjectBean();
    	studentToProjectBean.setObjectID(Integer.valueOf(resultSet.getInt("ObjectID")));
    	studentToProjectBean.setStudentID(Integer.valueOf(resultSet.getInt("StudentID")));
    	studentToProjectBean.setProjectID(Integer.valueOf(resultSet.getInt("ProjectID"))); 
		return studentToProjectBean;
	}
	
}
